// ici on conserve le gcrt0.S avec ses initialisation et on *modifie*
// la table des vecteurs d'interruption plutot que de vouloir la
// redefinir
// une des differences entre les differents MSP430 est la taille et le
// contenu de la table des vecteurs d'interruption => NE PAS les definir
// par des .word car ce n'est pas portable
// /opt/cdk4msp/bin/msp430-jtag -l /dev/.static/dev/parport1 -e jmf

#include <signal.h>
#include <io.h>

//#define hi	1	
	
;		RTC variables
#define         SEC     R13            
#define         MIN     R14            
#define         HR      R15            

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET:          ;MOV     #__stack,R1     ; Initialize stackpointer 0x0280
		MOV.W     #0x280,R1
		
                CALL    #Setup          ; Prepare LCD and basic timmer
		call 	#ad9954init
;		call 	#adf4360_init

Mainloop:       BIS     #LPM3,R2        ; Set SR bits for LPM3
                CALL    #Clock          ; Update Clockifdef
		xor.b	#2,&P1OUT 
//		mov.b	255,&P1OUT 
		nop

TX1:		bit.b	#UTXIFG0,&IFG1	; p.13-29: UTXIFG0 set when U0TXBUF empty
		jz	TX1
		mov.b	SEC,&TXBUF0	;
	
TX2:		bit.b	#UTXIFG0,&IFG1
		jz	TX2
		mov.b	MIN,&TXBUF0	;
	
TX3:		bit.b	#UTXIFG0,&IFG1
		jz	TX3
		mov.b	HR,&TXBUF0	;

		call #ftw0

                JMP     Mainloop        ; Endless Loop

;----------------------------------------------------------------------------- 
;    Clock: Update clock SEC and MIN and HR
;    Originally written by Lutz Bierl.
;    This is the routine that counts the hours, minutes and seconds.
;    It can be used with any counter peripheral on any MSP430 device,
;    as long as it is executed once per second.
;    This particular routine is very basic.  It only counts minutes, seconds
;    and hours as BCD numbers.  Hex values could also be used if desired.
;    Refer to the MSP430 Application Report Book for more extensive clock
;    routines that include counters for years, adjustments for leap years, etc.
;----------------------------------------------------------------------------- 

Clock:          SETC                    ; Set Carry bit.
                DADC.b  SEC             ; Increment seconds decimally
                CMP.b   #0x60,SEC       ; One minute elapsed?
                JLO     Clockend        ; No, return
                CLR.b   SEC             ; Yes, clear seconds
                DADC.b  MIN             ; Increment minutes decimally
                CMP.b   #0x60,MIN       ; Sixty minutes elapsed?
                JLO     Clockend        ; No, return
                CLR.b   MIN             ; yes, clear minutes
                DADC.b  HR              ; Increment Hours decimally
                CMP.b   #0x24,HR        ; 24 hours elapsed?
                JLO     Clockend        ; No, return
                CLR.b   HR              ; yes, clear hours	
Clockend:       RET                     ;

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV     #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

setupTA:        MOV     #TASSEL0+TACLR, &TACTL  ; ACLK for Timer_A.
                BIS     #CCIE,&CCTL0            ; Enable CCR0 interrupt.
                ;MOV     #0x7FFF,&CCR0           ; load CCR0 with 32,767.
                MOV     #0x01FF,&CCR0           ; load CCR0 with 32,767.
                BIS     #MC0,&TACTL             ; start TA in "up to CCR0" mode

ClearRTC:       MOV.b   #0,SEC                  ; Clear SEC
                MOV.b   #0,MIN                  ; Clear MIN
                MOV.b   #0,HR                   ; Clear HR
                EINT                            ; Enable interrupts

		MOV	 #0,&P1OUT		; jmf
		MOV	 #0,&P1SEL		; jmf
		MOV	 #0xff,&P1DIR		; jmf
		MOV	 #0,&P1IES		; jmf
		MOV	 #0,&P1IE		; jmf

#ifdef hi
		call #SetupOsc		; A VIRER SI ON PREND 32 kHz
		call #SetupUART0
		call #SetupP3
#else		
		call #SetupUART0
		call #SetupUART1
		call #SetupP3
#endif
                RET                     ; Done with setup.

SetupOsc: 	bic.b #XT2OFF,&BCSCTL1 	; XT2on
		bic.b #OFIFG,&IFG1 	; Clear OSC fault flag
		mov #0xFF,R15 		; R15 = Delay
SetupOsc1: 	dec R15 		; Additional delay ensure start
		jnz SetupOsc1 		;
		bit.b #OFIFG,&IFG1 	; OSC fault flag set?
		jnz SetupOsc 		; OSC Fault, clear flag again
		bis.b #SELM1+SELS,BCSCTL2 ; MCLK = SMCLK = XT2
		bis.b #DIVS1, BCSCTL2 	; Divide by 4 for SMCLK
		ret
; ***************** ADF4360 init ************************************
adf4360_init:
		bic.b 	#0x10,&P5OUT		; CS#lo
		mov.b	#0x00,R14		; R register
		call 	#spi_snd
		mov.b	#0x01,R14		; 
		call 	#spi_snd
		mov.b	#0x69,R14		; 
		call 	#spi_snd
		bis.b 	#1,&P5OUT		; CS#hi
		call 	#IO_UP
	
		bic.b 	#0x10,&P5OUT		; CS#lo
		mov.b	#0x8f,R14		; control
		call 	#spi_snd
		mov.b	#0xf1,R14		; 
		call 	#spi_snd
		mov.b	#0x04,R14		; 
		call 	#spi_snd
		bis.b 	#1,&P5OUT		; CS#hi
		call 	#IO_UP
	
		bic.b 	#0x10,&P5OUT		; CS#lo
		mov.b	#0x01,R14		; N register
		call 	#spi_snd
		mov.b	#0x6F,R14		; CFR1
		call 	#spi_snd
		mov.b	#0x1A,R14		; CFR1
		call 	#spi_snd
		bis.b 	#1,&P5OUT		; CS#hi
		call 	#IO_UP
		ret	

; ***************** AD9954 init ************************************
ad9954init:
		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#00,R14		; CFR1
		call 	#spi_snd
		mov.b	#00,R14		; CFR1
		call 	#spi_snd
		mov.b	#0x20,R14	; CFR1
		call 	#spi_snd
		mov.b	#00,R14		; CFR1
		call 	#spi_snd
		mov.b	#0x08,R14	; CFR1
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP
		
		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#01,R14		; CFR2
		call 	#spi_snd
		mov.b	#00,R14		; CFR2
		call 	#spi_snd
		mov.b	#0x00,R14	; CFR2
		call 	#spi_snd
		mov.b	#00,R14		; CFR2
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP

		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#02,R14		; ASF
		call 	#spi_snd
		mov.b	#00,R14		; ASF
		call 	#spi_snd
		mov.b	#0x00,R14	; ASF
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP

		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#03,R14		; ARR
		call 	#spi_snd
		mov.b	#0x00,R14	; ARR
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP

		call 	#ftw0

		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#05,R14		; POW0
		call 	#spi_snd
		mov.b	#0x00,R14	; POW0
		call 	#spi_snd
		mov.b	#0x00,R14	; POW0
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP
		
		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#06,R14		; FTW1
		call 	#spi_snd
		mov.b	#0x2c,R14	; FTW1
		call 	#spi_snd
		mov.b	#0x89,R14	; FTW1
		call 	#spi_snd
		mov.b	#0xa0,R14	; FTW1
		call 	#spi_snd
		mov.b	#0x27,R14	; FTW1
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP
		
		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#07,R14		; RSCW0
		call 	#spi_snd
		mov.b	#0x32,R14	; RSCW0
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW0
		call 	#spi_snd
		mov.b	#0x1d,R14	; RSCW0
		call 	#spi_snd
		mov.b	#0x7d,R14	; RSCW0
		call 	#spi_snd
		mov.b	#0xbf,R14	; RSCW0
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP

		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#08,R14		; RSCW1
		call 	#spi_snd
		mov.b	#0x32,R14	; RSCW1
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW1
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW1
		call 	#spi_snd
		mov.b	#0x3a,R14	; RSCW1
		call 	#spi_snd
		mov.b	#0xdb,R14	; RSCW1
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP
		
		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#09,R14		; RSCW2
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW2
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW2
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW2
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW2
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW2
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP

		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#0x0a,R14	; RSCW3
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW3
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW3
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW3
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW3
		call 	#spi_snd
		mov.b	#0x00,R14	; RSCW3
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP
		ret

ftw0:		bic.b 	#1,&P5OUT	; CS#lo
		mov.b	#04,R14		; FTW0
		call 	#spi_snd
		mov.b	#0x2a,R14	; FTW0
		call 	#spi_snd
		; mov.b	#0x4d,R14	; FTW0
		mov.b	SEC,R14
		call 	#spi_snd
		mov.b	#0xd2,R14	; FTW0
		call 	#spi_snd
		mov.b	#0xf1,R14	; FTW0
		call 	#spi_snd
		bis.b 	#1,&P5OUT	; CS#hi
		call 	#IO_UP
		ret

spi_snd:
		mov.b	R14,&TXBUF1	; CFR1
TXspi:		bit.b	#TXEPT,&UTCTL1
		jnc	TXspi
		ret
	
IO_UP:
		bis.b	#0x04,&P5OUT
		nop
		nop
		bic.b	#0x04,&P5OUT
		ret

; ***************** UART 0 Initialisation **************************
; nb: SMCLK has been divided by 4, must compensate for divider register
SetupUART0: 	mov.b #SWRST,&UCTL0	; cf p.13-4
		bis.b #CHAR,&UCTL0 	; 8-bit characters: 13-22
#ifdef hi
		mov.b #SSEL1,&UTCTL0 	; UCLK = SMCLK
		mov.b #78,&UBR00 	; 4.9152 Mhz 9600 - 
		mov.b #0x00,&UBR10 	; 
		mov.b #0x00,&UMCTL0 	; 4.9152 MHz no modulation 4800
#else
		mov.b #SSEL0,&UTCTL0 	; UCLK = ACLK @ 32768 Hz
		mov.b #0x03,&UBR00 	; 
		mov.b #0x00,&UBR10 	; cf p.13-16: 9600 bauds +/- 15%
		mov.b #0x4A,&UMCTL0 	; 
#endif
		bic.b #SWRST,&UCTL0 
		bis.b #UTXE0+URXE0,&ME1 ; Enable USART0 TXD/RXD
		nop
		ret

; ***************** UART 1 Initialisation
; nb: SMCLK has been divided by 4, must
SetupUART1: 	mov.b #SWRST,&UCTL1	; cf p.13-4
		bis.b #CHAR+SYNC+MM,&UCTL1	; 8 bit data
		mov.b #SSEL0+STC,&UTCTL1	; 3 wire protocol (STC)
		mov.b #0x02,&UBR01
		mov.b #0x00,&UBR11
		mov.b #0x00,&UMCTL1
		bic.b #SWRST,&UCTL1 
		bis.b #0x10,&ME2	; pour le MSP149
		nop
		ret

; ***************** Port 3 & 5 Initialisation **************************
SetupP3: 	bis.b #0xF0,&P3SEL ; P3.4,5,6,7 = USART select
		bis.b #0x50,&P3DIR ; P3.4,6 = output direction
SetupP5: 	bis.b #0x0A,&P5SEL ; P5.0,1,2,3 = USART select
		bis.b #0x11,&P5OUT ;
		bis.b #0xF5,&P5DIR ; P5.0,2,4-7 = output direction
		ret ;
; ***************** Interrupts Initialisation **************************
;IntInit: 	bis.b #URXIE0,&IE1 ; Enable USART0 RX interrupt
;		bis.b #URXIE1,&IE2 ; Enable USART1 RX interrupt
;		; eint ; General enable interrupts
;		ret

;----------------------------------------------------------------------------- 
;       Timer_A ISR:
;       CPU is simply returned to active state on RETI by manipulated the SR
;       bits in the SR value that was pushed onto the stack.
;       CCR0 IFG is reset automatically.
;----------------------------------------------------------------------------- 

interrupt(TIMERA0_VECTOR)               ;register interrupt vector
.global CCR0INT                         ;place a label afterwards so
CCR0INT:        BIC     #LPM3,0(R1)     ; Clear SR LPM3 Bits, on top of stack
                RETI                    ;
