// OK varicap sur resonateur 
// OK PWM puis LPF en sortie
// OK ADC12 pour mesurer T (channel 0x0A) : Vtemp=0.00355*(Tc)+0.986 p.17-16
//        mesurer freq en fontion de T
// OK balayer tension de polar de varicap et voir comment f_osc varie (deja
//        tester avec capas fixes pour choisir la varicap p.r a 12 pF)
// 5000000%65536=19264 et 5000000/65536=76 => voir meme chose sur osc RF

; attention a P1SEL pour selectionner le mode de fonctionnement d'une broche

// ici on conserve le gcrt0.S avec ses initialisation et on *modifie*
// la table des vecteurs d'interruption plutot que de vouloir la
// redefinir
// une des differences entre les differents MSP430 est la taille et le
// contenu de la table des vecteurs d'interruption => NE PAS les definir
// par des .word car ce n'est pas portable
// /opt/cdk4msp/bin/msp430-jtag -l /dev/.static/dev/parport1 -e jmf

#include <signal.h>
#include <io.h>

#define		asservit
#define 	tabdebut	0x600	//start du tableau stockant 
#define 	tabfin		0x61c	//stop du tableau -> taille 0x1c=14 
                                        // vals (on sauve des short).
#define 	nbbalayage	4


#define         tmp     R15	//			<- 1er param de PID
#define 	addr	R14	// RAM=0x200-0x9FF	<- 2eme param de PID
#define         DAC     R13	//  polar varicap	<- 3eme param de PID
#define         CPT     R10	

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET: 
	MOV.W   #0x280,R1	; stack = 0x200-0x280
        CALL    #Setup

	mov.w	#0,CPT
	mov.w	#0,DAC

	mov	#0x600,addr	; place le tableau dans la RAM A l'adresse 0x600
	mov.w	#0,&0x300
	mov.w	#0,&0x2F8
	
zero:				; init tableau a 0
	cmp	#tabfin,addr	
	jeq	finzero	
	mov.w	#0,@addr
	inc.w	addr		; inc 2 fois car on est en short (2 octets)
	inc.w	addr
	jmp	zero
finzero:	
	mov	#0x600,addr

Mainloop:
	mov.b	#0,tmp
at:     CMP.b   #1,tmp		; NE PAS se mettre en sleep qui coupe osc
	jne	at		; interruption nous sort de la boucle
	
//	xor.b	#4,&P1OUT 	; A VIRER POUR ETRE STABLE (pas de LED) !
	
// Creation du tableau avec retour au debut en gardant la valeur finale 
// du tableau qui contiendra les valeurs capturees du timer A.

	inc.b	CPT
	cmp	#tabfin,addr	; si on est en fin de tablo
	jne	finadr		; alors on deplace l'element courant en
	mov	@addr,tmp	; ... debut de tablo et on y va
	mov	#tabdebut,addr
	mov	tmp,@addr	
finadr:	
	inc.w	addr		; inc 2 fois car on est en short (2 octets)
	inc.w	addr

	mov	addr,tmp	; envoi adresses de stockage de timer A
	call 	#rs_TX
	swpb	tmp
	call 	#rs_TX
	
// Balayage en frequence en fonction de la valeur du DAC.
lcpt:   CMP.b   #nbbalayage,CPT ; fait nbbalayage acqusitions par valeur de DAC
	jne	suitecpt
	mov.b	#0,CPT

#ifndef asservit
	add.w	#0x01,DAC	// incremente de 1 la valeur du DAC	
	cmp.w	#1400,DAC	// valeur limite du DAC (sinon pas d'osc)
	jne	dacok
	mov.w	#0x00,DAC	// remise a zero de la valeur du DAC
dacok:	mov.w	DAC,&TBCCR3	; inc DAC
#endif
// fin de la boucle de calibration

suitecpt:			
	mov.w	&CCR0,tmp	; read timer A input capture current value // Stoque la valeur du timer A dans tmp qui est stockée ensuite dans le tableau au dessus.
	
boucle:	
	call 	#rs_TX 		// envoi sur port com la val du timer A
	swpb	tmp
	call 	#rs_TX
	swpb	tmp

#ifdef asservit
	push	R15
	push	R14		; on veut se rappeler de la position du tablo
	; push	R13		; DAC va etre remplace par PID.c
	push	R12		; R11 et R12 seront modifies pas PID.c
	push	R11
	CALL    #pid		
	mov.w	tmp,DAC		; return() dans R15 
	call 	#rs_TX		; envoi de la commande sur port com.
	swpb	tmp
	call 	#rs_TX
	
	mov.w	DAC,&TBCCR3 	; commande -> PWM ie DAC
	pop	R11
	pop	R12
	; pop	R13		; pas de push donc pas de pop
	pop	R14
	pop	R15
	
//Envoi de somme de pid sur port com :	
	
	mov.w	&0x300,tmp
	call 	#rs_TX
	swpb	tmp
	call 	#rs_TX
#else
	mov.w	DAC,tmp
	call 	#rs_TX
	swpb	tmp
	call 	#rs_TX
	swpb	tmp
	call 	#rs_TX
	swpb	tmp
	call 	#rs_TX
	swpb	tmp
#endif

; a chaque PPS, on renvoie la temperature du MSP430 => courbe f(T)
	call	#SetupADC12
	call 	#rs_TX
	swpb	tmp
	call 	#rs_TX

        JMP     Mainloop       

//////// send tmp on UART0 ////////
rs_TX:	bit.b	#UTXIFG0,&IFG1	; p.13-29: UTXIFG0 set when U0TXBUF empty
	jz	rs_TX
	mov.b	tmp,&TXBUF0
	ret

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV.w   #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

/* Configuration des registres du Timer A pour capturer a chaque seconde du GPS,le contenu de l'horloge, afin de verifier par la suite la difference entre la 
seconde du quartz de 32 kHz et la seconde du GPS*/
			
//setupTA:      MOV     #TASSEL0+TACLR, &TACTL  ; ACLK for Timer_A.
setupTA:        MOV.w   #TASSEL1+TACLR, &TACTL  ; SMCLK for Timer_A.
                BIS	#MC1,&TACTL        	; start TA in "up to FFFF" mode
		mov.w	#CM0+CAP+CCIE+SCS,&TACCTL0	; mode capture sur front montant
// jmfriedt: /opt/cdk4msp/msp430/include/msp430/timera.h

		MOV	#0x14,&P1OUT
		MOV	#0x12,&P1SEL		; p.9-4: P1_1 is TA, NOT GPIO //patte 16 selectionnée pour un autre périph.(analyseur
		MOV	#0x14,&P1DIR
                EINT                            ; Enable interrupts

 		call	#SetupUART0
		call	#SetupP3

setupTB:	bis.b	#0x08,&P4SEL		; TB3 for PWM (pin 39)
		bis.b	#0x08,&P4DIR		; TB3 for output
		MOV.w   #TBSSEL1+TBCLR, &TBCTL  ; SMCLK for Timer_B.
		mov.w	#CCIE,&TBCCTL0		; compare mode 
		mov.w	#0xFFF,&TBCCR0		; period of PWM: 8 bits DAC
		mov.w	#0x02E0,&TBCCTL3	// Capture/Compare Control Register:Outmod :111 Reset/set	CLLD:01 TBCLx loads when TBR counts to 0
		mov.w	#0x30,&TBCCR3		; Vout initial 
		bis	#MC0,&TBCTL
		
// a faire en dernier, apres que tous les ports soient OK (TBCCR3 initialized)
		call	#SetupOsc

                RET				; Done with setup.


//////////////////////////////////////////////////////////////////////////
SetupADC12:	; book C. Nagy p.90
		mov.w	#SHT0_6+SHT1_6+REFON+ADC12ON,&ADC12CTL0
		mov.w	#SHP,&ADC12CTL1
		mov.b	#INCH_10+SREF_1,&ADC12MCTL0 ; p.17-11: single conversion
		bis.w	#ENC+ADC12SC,&ADC12CTL0		; MUST be .w jmfriedt
adc:		bit.b	#1,&ADC12CTL1	; wait while ADC busy==1
		jnz	adc
		mov.w	&ADC12MEM0,tmp	; conversion result
		ret

//////////////////////////////////////////////////////////////////////////
SetupOsc: 	bic.b 	#XT2OFF,&BCSCTL1 	; XT2on
		bic.b 	#OFIFG,&IFG1 		; Clear OSC fault flag
		mov 	#0xFF,R15 		; R15 = Delay
SetupOsc1: 	dec 	R15 			; Additional delay ensure start
		jnz 	SetupOsc1 		;
		bit.b 	#OFIFG,&IFG1 		; OSC fault flag set?
		jnz 	SetupOsc 		; OSC Fault, clear flag again
		bis.b 	#SELM0+SELS,&BCSCTL2 	; MCLK = SMCLK = XT2      ?SELS?
		;mov.b	#0x56,&DCOCTL	;; A VIRER ?
		;; un nop a cet endroit fait planter l'execution !
		ret

; ***************** UART 0 Initialisation **************************
; nb: SMCLK has been divided by 4, must compensate for divider register
	
SetupUART0: 	mov.b 	#SWRST,&UCTL0		; cf p.13-4
		bis.b 	#CHAR,&UCTL0 		; 8-bit characters: 13-22
		mov.b 	#SSEL0,&UTCTL0 		; UCLK = ACLK @ 32768 Hz
		mov.b 	#0x03,&UBR00 		; 
		mov.b 	#0x00,&UBR10 		; cf p.13-16: 9600 bauds +/- 15%
		mov.b 	#0x4A,&UMCTL0 		; 
		bic.b 	#SWRST,&UCTL0 
		bis.b 	#UTXE0+URXE0,&ME1 	; Enable USART0 TXD/RXD
		nop
		ret

; ***************** Port 3 Initialisation **************************
SetupP3: 	bis.b 	#0xF0,&P3SEL 		; P3.4,5,6,7 = USART select
		bis.b 	#0x50,&P3DIR 		; P3.4,6 = output direction
		ret ;

;----------------------------------------------------------------------------- 

; jmfriedt: /opt/cdk3msp/msp430/include/msp430x14x.h pour les diverses tables 
; l'exemple TI qui definit une table fixe et se compile sans entete est mauvais
interrupt(TIMERA0_VECTOR)               ; register interrupt vector
.global CCR0INT                         
CCR0INT: 	mov.b	#1,tmp		; set flag
                RETI

interrupt(TIMERB0_VECTOR)
.global CCIFG0
CCIFG0: 	RETI			; leave CCR3 unchanged for DAC
