// ici on conserve le gcrt0.S avec ses initialisation et on *modifie*
// la table des vecteurs d'interruption plutot que de vouloir la
// redefinir
// une des differences entre les differents MSP430 est la taille et le
// contenu de la table des vecteurs d'interruption => NE PAS les definir
// par des .word car ce n'est pas portable
// /opt/cdk4msp/bin/msp430-jtag -l /dev/.static/dev/parport1 -e jmf

// l'exemple GPS utilise une horloge externe pour 115 kbps. Ici 9600 bauds
// donc on ne prend que le quartz a 32768 Hz

#include <signal.h>
#include <io.h>

//#undef hi 	// quartz haute freq pour communiquer plus vite que 9600 bps
	
;		RTC variables
#define         SEC     R13            
#define         MIN     R14            
#define         HR      R15            

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET:          MOV.W   #0x280,R1
		
                CALL    #Setup          ; Prepare LCD and basic timmer

Mainloop:       BIS     #LPM3,R2        ; Set SR bits for LPM3
                CALL    #Clock          ; Update Clock
		
		push	r15
		push	r14
		push	r13

	
		CALL    #jmf_alarme     ; 
		cmp.b	#1,R15
		jne	pas1
		mov.w	#0xC000,R7

attend:		dec	R7
		jnz	attend
		bic	#0x02,&P1OUT

pas1:
		
	
		pop	r13
		pop	r14
		pop	r15
		nop

TX1:		bit.b	#UTXIFG0,&IFG1	; p.13-29: UTXIFG0 set when U0TXBUF empty
		jz	TX1
		mov.b	SEC,&TXBUF0	;
	
TX2:		bit.b	#UTXIFG0,&IFG1
		jz	TX2
		mov.b	MIN,&TXBUF0	;
	
TX3:		bit.b	#UTXIFG0,&IFG1
		jz	TX3
		mov.b	HR,&TXBUF0	;
	
//		mov.w	#0x9000,R7
//attend:	dec	R7
//		jnz	attend
//		mov.b	00,&P1OUT 

                JMP     Mainloop        ; Endless Loop

;----------------------------------------------------------------------------- 
;    Clock: Update clock SEC and MIN and HR
;    Originally written by Lutz Bierl.
;    This is the routine that counts the hours, minutes and seconds.
;    It can be used with any counter peripheral on any MSP430 device,
;    as long as it is executed once per second.
;    This particular routine is very basic.  It only counts minutes, seconds
;    and hours as BCD numbers.  Hex values could also be used if desired.
;    Refer to the MSP430 Application Report Book for more extensive clock
;    routines that include counters for years, adjustments for leap years, etc.
;----------------------------------------------------------------------------- 

Clock:          SETC                    ; Set Carry bit.
                DADC.b  SEC             ; Increment seconds decimally
                CMP.b   #0x60,SEC       ; One minute elapsed?
                JLO     Clockend        ; No, return
                CLR.b   SEC             ; Yes, clear seconds
                DADC.b  MIN             ; Increment minutes decimally
                CMP.b   #0x60,MIN       ; Sixty minutes elapsed?
                JLO     Clockend        ; No, return
                CLR.b   MIN             ; yes, clear minutes
                DADC.b  HR              ; Increment Hours decimally
                CMP.b   #0x24,HR        ; 24 hours elapsed?
                JLO     Clockend        ; No, return
                CLR.b   HR              ; yes, clear hours	
Clockend:       RET                     ;

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV     #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

setupTA:        MOV     #TASSEL0+TACLR, &TACTL  ; ACLK for Timer_A.
                BIS     #CCIE,&CCTL0            ; Enable CCR0 interrupt.
                MOV     #0x7FFF,&CCR0           ; load CCR0 with 32,767.
                BIS     #MC0,&TACTL             ; start TA in "up to CCR0" mode

ClearRTC:       MOV.b   #0,SEC                  ; Clear SEC
                MOV.b   #0,MIN                  ; Clear MIN
                MOV.b   #0,HR                   ; Clear HR
                EINT                            ; Enable interrupts

		MOV	 #0,&P1OUT		; jmf
		MOV	 #0,&P1SEL		; jmf
		MOV	 #0xff,&P1DIR		; jmf
		MOV	 #0,&P1IES		; jmf
		MOV	 #0,&P1IE		; jmf

#ifdef hi
		call #SetupOsc		; A VIRER SI ON PREND 32 kHz
		call #SetupUART0
		call #SetupP3

#else		
		call #SetupUART0
		call #SetupP3

#endif
//		nop 			; NECESSAIRE ?!
                RET                     ; Done with setup.

SetupOsc: 	bic.b #XT2OFF,&BCSCTL1 	; XT2on
		bic.b #OFIFG,&IFG1 	; Clear OSC fault flag
		mov #0xFF,R15 	; R15 = Delay
SetupOsc1: 	dec R15 		; Additional delay ensure start
		jnz SetupOsc1 ;
		bit.b #OFIFG,&IFG1 	; OSC fault flag set?
		jnz SetupOsc 		; OSC Fault, clear flag again
		bis.b #SELM1+SELS,BCSCTL2 ; MCLK = SMCLK = XT2
		bis.b #DIVS1, BCSCTL2 	; Divide by 4 for SMCLK
		;; un nop a cet endroit fait planter l'execution !
		ret

; ***************** UART 0 Initialisation **************************
; nb: SMCLK has been divided by 4, must compensate for divider register
SetupUART0: 	mov.b #SWRST,&UCTL0	; cf p.13-4
		bis.b #CHAR,&UCTL0 	; 8-bit characters: 13-22
#ifdef hi
		mov.b #SSEL1,&UTCTL0 	; UCLK = SMCLK
		mov.b #78,&UBR00 	; 4.9152 Mhz 9600 - 
		mov.b #0x00,&UBR10 	; 
		mov.b #0x00,&UMCTL0 	; 4.9152 MHz no modulation 4800
#else
		mov.b #SSEL0,&UTCTL0 	; UCLK = ACLK @ 32768 Hz
		mov.b #0x03,&UBR00 	; 
		mov.b #0x00,&UBR10 	; cf p.13-16: 9600 bauds +/- 15%
		mov.b #0x4A,&UMCTL0 	; 
#endif
		bic.b #SWRST,&UCTL0 
		bis.b #UTXE0+URXE0,&ME1 ; Enable USART0 TXD/RXD
		nop
		ret
; ***************** UART 1 Initialisation
; nb: SMCLK has been divided by 4, must
;SetupUART1: 	mov.b #CHAR,&UCTL1
;		mov.b #SSEL1,&UTCTL1
;		mov.b #0x08,&UBR01
;		mov.b #0x00,&UBR11
;		mov.b #0x00,&UMCTL1
;		bis.b #UTXE1+URXE1,&ME2
;		ret
; ***************** Port 3 Initialisation **************************
SetupP3: 	bis.b #0xF0,&P3SEL ; P3.4,5,6,7 = USART select
		bis.b #0x50,&P3DIR ; P3.4,6 = output direction
		ret ;
; ***************** Interrupts Initialisation **************************
;IntInit: 	bis.b #URXIE0,&IE1 ; Enable USART0 RX interrupt
;		bis.b #URXIE1,&IE2 ; Enable USART1 RX interrupt
;		; eint ; General enable interrupts
;		ret

;----------------------------------------------------------------------------- 
;       Timer_A ISR:
;       CPU is simply returned to active state on RETI by manipulated the SR
;       bits in the SR value that was pushed onto the stack.
;       CCR0 IFG is reset automatically.
;----------------------------------------------------------------------------- 

interrupt(TIMERA0_VECTOR)               ;register interrupt vector
.global CCR0INT                         ;place a label afterwards so
CCR0INT:        BIC     #LPM3,0(R1)     ; Clear SR LPM3 Bits, on top of stack
                RETI                    ;
