#include <signal.h>
#include <io.h>

;		RTC variables
#define		tmp	R15
#define		tmp2	R14
#define 	portAPNout	P1OUT
#define 	portAPNin	P3IN
#define 	portAPNsel	P1SEL
#define 	portAPNdir	P1DIR

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET:          ;MOV     #__stack,R1     ; Initialize stackpointer 0x0280
		MOV.W     #0x280,R1
		
                CALL    #Setup          ; Prepare LCD and basic timmer

	mov.b	#0x20,tmp
Mainloop:
	call	#rs_rx0
	call	#rs_tx1

	xor.b	#0xC0,&portAPNout	; blinking diodes 

        JMP     Mainloop        ; Endless Loop

rs_tx0:	bit.b	#UTXIFG0,&IFG1	; p.13-29: UTXIFG0 set if U0TXBUF empty
	jz	rs_tx0
	mov.b	tmp,&TXBUF0	;
	ret

rs_tx1:	bit.b	#UTXIFG1,&IFG2	
	jz	rs_tx1
	mov.b	tmp,&TXBUF1	;
	ret
	
rs_rx0: bit.b	#URXIFG0,&IFG1	
	jz	rs_rx0		; char recu
	mov.b	&RXBUF0,tmp
	ret

rs_rx1: bit.b	#URXIFG1,&IFG2	; serial port 1
	jz	rs_rx1		; char recu
	mov.b	&RXBUF1,tmp
	ret

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV     #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

setupTA:        
		MOV	 #0,&P1IES		; jmf
		MOV	 #0,&P1IE		; jmf

		call #SetupUART0
		call #SetupUART1
		call #SetupP3

                RET                     ; Done with setup.

; ***************** UART 0 Initialisation **************************
SetupUART0: 	mov.b #SWRST,&UCTL0	; cf p.13-4
		bis.b #CHAR,&UCTL0 	; 8-bit characters: 13-22
		mov.b #SSEL0,&UTCTL0 	; UCLK = ACLK @ 32768 Hz
		mov.b #0x06,&UBR00 	; 
		mov.b #0x00,&UBR10 	; cf p.13-16: 4800 bauds +/- 15%
		mov.b #0x6F,&UMCTL0 	; 
		bic.b #SWRST,&UCTL0 
		bis.b #UTXE0+URXE0,&ME1 ; Enable USART0 TXD/RXD
		nop
		ret
; ***************** UART 1 Initialisation
SetupUART1: 	mov.b #SWRST,&UCTL1	; cf p.13-4
	 	bis.b #CHAR,&UCTL1
		mov.b #SSEL0,&UTCTL1
		mov.b #0x03,&UBR01	; 9600 bauds
		mov.b #0x00,&UBR11
		mov.b #0x4A,&UMCTL1
		bic.b #SWRST,&UCTL1 
		bis.b #UTXE1+URXE1,&ME2
		ret
; ***************** Port 3 Initialisation **************************
SetupP3: 	mov.b #0xF0,&P3SEL ; P3.6,7 = USART select
		mov.b #0x50,&P3DIR ; P3.6 = output direction
		mov.b #0x00,&P3OUT ; P3.6 = output val
		mov.b #0xEF,&portAPNdir
		mov.b #0x00,&portAPNsel
		mov.b #0x00,&portAPNout

		ret ;

delai:
	mov.b  	#16,tmp2
del1:	mov.w	#0xffff,tmp
del2:	dec.w	tmp
	jnz	del2
	dec.b	tmp2
	jnz	del1
	ret
