; 070911 : passage dans comm du port serie en entree
; 070909 : sauve params de prise de vue dans flash, init val =12:00:00
; 070828 : emission sur UART1
; 070730: marche bien avec rtc.c mais quid avec soft christian ?
;         ecrire en flash au lieu de RAM
;         optimiser bcd2bin
;		dans la lecture des params, faire bcd2bin APRES reception
; christian :	lecture tension USB ?
; christian :	commande regulateur 5V ?
; christian : ajouter le cable USB et l'ENA# du Vreg <-- TODO

#define debug

#include <signal.h>
#include <io.h>

;		RTC variables
#define         SEC     R13            
#define         MIN     R14            
#define         HR      R15            
#define 	almHR	R12
#define 	almMIN	R11
#define 	num	R10
#define		tmp	R9
#define		tmp2	R8
#define		tmp3	R7
#define		tmp4	R6
#define		tmp5	R5
; P4.0 = power ON/OFF, P4.1 = prise de vue, P4.4 = detection alim
; #define 	portAPNout	P4OUT
#define 	portAPNout	P1OUT
#define 	portAPNin	P3IN
#define 	portAPNsel	P1SEL
#define 	portAPNdir	P1DIR

;0x1000=incalmMIN
;0x1002=incalmHR
;0x1004=inialmMIN
;0x1006=inialmHR
;0x1008=iniN

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET:          ;MOV     #__stack,R1     ; Initialize stackpointer 0x0280
		MOV.W     #0x280,R1
		
                CALL    #Setup          ; Prepare LCD and basic timmer

#ifdef debug
	call 	#flash_rmw	; erase flash mem block
	mov	#0x1000,tmp2	; increment alarm MIN
	mov  	#0x01,tmp		
	mov.b	tmp,&0x700
	call 	#flash_cpw

	mov	#0x1002,tmp2	; increment alarm HR
	mov  	#0x02,tmp		
	mov.b	tmp,&0x702
	call 	#flash_cpw

	mov	#0x1004,tmp2	; initial alarm MIN
	mov  	#0x02,tmp		
	mov.b	tmp,&0x704
	call 	#flash_cpw

	mov	#0x1006,tmp2	; initial alarm HR
	mov  	#0x08,tmp		
	mov.b	tmp,&0x706
	call 	#flash_cpw
	
	mov	#0x1008,tmp2	; initial num
	mov  	#0x06,tmp		
	mov.b	tmp,&0x708
	call 	#flash_cpw

#endif
	call	#chargeparams
#ifdef debug
	call #dumpall	; POUR DEBUG
	mov.b	#0xff,tmp
	call	#rs_tx
	call	#rs_tx
#endif
;mov	&0x1008,num
;mov	&0x1006,almHR
;mov	&0x1008,num

; call #incalm	; pour tester les increments

Mainloop:       BIS     #LPM3,R2        ; Set SR bits for LPM3
#                CALL    #Clock          ; Update Clock <- pas ici sinon on perd
					 ; des secondes pendant prise de vue
		CALL	#Alarm

;	 a chaque seconde je teste le RS232 : si haut, alors on communique
		call	#comm

#ifdef debug
		xor.b	#0xE0,&portAPNout	; blinking diodes 
		mov.b	SEC,tmp
		call	#rs_tx

		mov.b	MIN,tmp
		call	#rs_tx

		mov.b	HR,tmp
		call	#rs_tx
#endif

                JMP     Mainloop        ; Endless Loop

rs_tx:		;bit.b	#UTXIFG0,&IFG1	; p.13-29: UTXIFG0 set if U0TXBUF empty
		;jz	rs_tx
		;mov.b	tmp,&TXBUF0	;
		bit.b	#UTXIFG1,&IFG2	
		jz	rs_tx
		mov.b	tmp,&TXBUF1	;
		ret
	
;----------------------------------------------------------------------------- 
;    Clock: Update clock SEC and MIN and HR
;    Originally written by Lutz Bierl.
;    This is the routine that counts the hours, minutes and seconds.
;    It can be used with any counter peripheral on any MSP430 device,
;    as long as it is executed once per second.
;    This particular routine is very basic.  It only counts minutes, seconds
;    and hours as BCD numbers.  Hex values could also be used if desired.
;    Refer to the MSP430 Application Report Book for more extensive clock
;    routines that include counters for years, adjustments for leap years, etc.
;----------------------------------------------------------------------------- 

Clock:          SETC                    ; Set Carry bit.
                DADC.b  SEC             ; Increment seconds decimally
                CMP.b   #0x60,SEC       ; One minute elapsed?
                JLO     Clockend        ; No, return
                CLR.b   SEC             ; Yes, clear seconds
                DADC.b  MIN             ; Increment minutes decimally
                CMP.b   #0x60,MIN       ; Sixty minutes elapsed?
                JLO     Clockend        ; No, return
                CLR.b   MIN             ; yes, clear minutes
                DADC.b  HR              ; Increment Hours decimally
                CMP.b   #0x24,HR        ; 24 hours elapsed?
                JLO     Clockend        ; No, return
                CLR.b   HR              ; yes, clear hours	
Clockend:       RET                     ;

Alarm:	
        CMP.b   #0x00,SEC      	; SEC <- SEC-0
	jne	pasalm
        CMP.b   almMIN,MIN 	; MIN <- MIN-almMIN     
	jne	pasalm
        CMP.b   almHR,HR      	; HR <- HR-almHR
	jne	pasalm
	
	dec.b	num
        CMP.b   #0x00,num       ; derniere photo de la journee ?
	jne	incal
	call	#chargeparams
	jmp	foto
incal:
	call	#incalm
foto:

; SEQUENCE DE prise de vu
mov	#0xF0,&P5OUT		; power on = ENA regul
call	#delai
mov	#0xA1,&portAPNout	; switch on
call	#delai
;mov	#0x00,&portAPNout	; focus
call	#delai
;mov	#0x02,&portAPNout	; take picture
mov	#0xD3,&portAPNout	; take picture
call	#delai
;mov	#0x00,&portAPNout	; save picture
call	#delai
mov	#0xC1,&portAPNout	; switch off
call	#delai
mov	#0x00,&P5OUT		; power off
call	#delai
mov	#0xE0,&portAPNout

#ifdef debug
call	#dumpall
#endif
; fin SEQUENCE
pasalm:	
	ret

incalm:
        CLRC           
        ; DADD.b  &0x1000,almMIN 	; add alm to MIN
        DADD.b  &0x0700,almMIN 	; add alm to MIN
	CMP.b   #0x60,almMIN 	; almMIN <- almMIN-60
        JLO     heure	
        SETC                    ; Set Carry bit.
        DADC.b  almHR           ; Increment seconds decimally
	sub.c	#0x60,almMIN
heure:
        CLRC           
        ; DADD.b  &0x1002,almHR  	; add alm to MIN
        DADD.b  &0x0702,almHR  	; add alm to MIN
        CMP.b   #0x24,almHR 
        JLO     finincalm
	sub.c	#0x24,almHR
finincalm:
	ret

chargeparams:
	mov	&0x1000,&0x700
	mov	&0x1002,&0x702
	mov	&0x1004,&0x704
	mov	&0x1006,&0x706
	mov	&0x1008,&0x708
	mov	&0x0704,almMIN
	mov	&0x0706,almHR
	mov	&0x0708,num
	ret
;0x1000=incalmMIN
;0x1002=incalmHR
;0x1004=inialmMIN
;0x1006=inialmHR
;0x1008=iniN

dumpall:			; reponse a '?' : 12 octets
	mov	#0x00,tmp	
	call	#rs_tx		; year
	call	#rs_tx		; month
	call	#rs_tx		; day
	mov	HR,tmp		; heures
	call 	#bcd2bin
	call 	#rs_tx
	mov	MIN,tmp		; min
	call 	#bcd2bin
	call 	#rs_tx
	; mov	&0x1006,tmp	; hrdep
	mov	&0x0706,tmp	; hrdep
	call 	#bcd2bin
	call 	#rs_tx
	; mov	&0x1004,tmp	; mindep
	mov	&0x0704,tmp	; mindep
	call 	#bcd2bin
	call 	#rs_tx
	; mov	&0x1002,tmp	; inchr
	mov	&0x0702,tmp	; inchr
	call 	#bcd2bin
	call 	#rs_tx
	; mov	&0x1000,tmp	; incmin
	mov	&0x0700,tmp	; incmin
	call 	#bcd2bin
	call 	#rs_tx
	; mov	&0x1008,tmp	; nbr/jr
	mov	&0x0708,tmp	; nbr/jr
	call 	#bcd2bin
	call 	#rs_tx
	mov	almHR,tmp	; almhr
	call 	#bcd2bin
	call 	#rs_tx
	mov	almMIN,tmp	; almmin
	call 	#bcd2bin
	call 	#rs_tx
	ret

comm:		; communication par port serie ?
	bit.b	#0x10,&portAPNin	; teste alim du port serie = P4.4
 	mov.b #0x00,&P3SEL ; P3.6,7 = USART select
	mov.b #0x40,&P3DIR ; P3.6 = output direction
	mov.b #0x00,&P3OUT ; P3.6 = output val
	jnz	recoit
	ret
recoit:
 	mov.b #0xC0,&P3SEL ; P3.6,7 = USART select
	mov.b #0x40,&P3DIR ; P3.6 = output direction
	mov.b #0x00,&P3OUT ; P3.6 = output val

	call 	#rs_rx
	cmp.b	#'?',tmp
	jne	s1
	call	#dumpall
	jmp	comm
s1:	cmp.b	#'P',tmp
	jne	s2
	call	#getall
	jmp	comm
s2:	cmp.b	#'S',tmp	; on ne fait rien !
	jne	s3
s3:	jmp	comm		; on n'a pas vu de char connu

rs_rx:
	; bit.b	#URXIFG0,&IFG1	; p.13-29: UTXIFG0 set if U0TXBUF empty
	bit.b	#URXIFG1,&IFG2	; p.13-29: UTXIFG0 set if U0TXBUF empty
	jnz	fin_rsrx	; char recu
	bit	#0x10,&portAPNin	; teste alim du port serie = P4.4
	jnz	rs_rx
	mov 	#0x20,tmp
	ret			; si pas recu de char et pas de cable rs232
fin_rsrx:
	; mov.b	&RXBUF0,tmp
	mov.b	&RXBUF1,tmp
	ret

getall:
	call	#rs_rx	; current year
	call	#rs_rx	; current month
	call	#rs_rx	; current day

	call	#rs_rx	; current hour
	mov	tmp,HR

	call	#rs_rx	; current min
	mov	tmp,MIN

	call	#rs_rx		; init hour
	mov	tmp,&0x706

	call	#rs_rx		; init min
	mov	tmp,&0x704

	call	#rs_rx		; inc hr
	mov	tmp,&0x702

	call	#rs_rx		; inc min
	mov	tmp,&0x700

	call	#rs_rx		; init num
	mov	tmp,&0x708

	mov	HR,tmp
	call	#bin2bcd
	mov	tmp,HR

	mov	MIN,tmp
	call	#bin2bcd
	mov	tmp,MIN
	
	call 	#flash_rmw	; erase flash mem block
	mov	&0x700,tmp
	call	#bin2bcd
	mov	tmp,&0x700
	mov	#0x1000,tmp2	; increment alarm MIN
	call 	#flash_cpw

	mov	&0x702,tmp
	call	#bin2bcd
	mov	tmp,&0x702
	mov	#0x1002,tmp2	; increment alarm HR
	call 	#flash_cpw

	mov	&0x704,tmp
	call	#bin2bcd
	mov	tmp,&0x704
	mov	#0x1004,tmp2	; initial alarm MIN
	call 	#flash_cpw

	mov	&0x706,tmp
	call	#bin2bcd
	mov	tmp,&0x706
	mov	#0x1006,tmp2	; initial alarm HR
	call 	#flash_cpw

	mov	&0x708,tmp
	mov	#0x1008,tmp2	; initial num
	call 	#flash_cpw

	call 	#chargeparams
	ret

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV     #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

setupTA:        MOV     #TASSEL0+TACLR, &TACTL  ; ACLK for Timer_A.
                BIS     #CCIE,&CCTL0            ; Enable CCR0 interrupt.
                MOV     #0x7FFF,&CCR0           ; load CCR0 with 32,767.
                BIS     #MC0,&TACTL             ; start TA in "up to CCR0" mode

ClearRTC:       MOV.b   #0,SEC                  ; Clear SEC
                MOV.b   #0,MIN                  ; Clear MIN
                MOV.b   #0x12,HR                ; Clear HR
                EINT                            ; Enable interrupts

		MOV	 #0,&P1IES		; jmf
		MOV	 #0,&P1IE		; jmf

		; call #SetupUART0
		call #SetupUART1
		call #SetupP3

                RET                     ; Done with setup.

; ***************** UART 0 Initialisation **************************
; nb: SMCLK has been divided by 4, must compensate for divider register
SetupUART0: 	mov.b #SWRST,&UCTL0	; cf p.13-4
		bis.b #CHAR,&UCTL0 	; 8-bit characters: 13-22
		mov.b #SSEL0,&UTCTL0 	; UCLK = ACLK @ 32768 Hz
		mov.b #0x03,&UBR00 	; 
		mov.b #0x00,&UBR10 	; cf p.13-16: 9600 bauds +/- 15%
		mov.b #0x4A,&UMCTL0 	; 
		bic.b #SWRST,&UCTL0 
		bis.b #UTXE0+URXE0,&ME1 ; Enable USART0 TXD/RXD
		nop
		ret
; ***************** UART 1 Initialisation
; nb: SMCLK has been divided by 4, must
SetupUART1: 	mov.b #SWRST,&UCTL1	; cf p.13-4
	 	bis.b #CHAR,&UCTL1
		mov.b #SSEL0,&UTCTL1
		mov.b #0x03,&UBR01
		mov.b #0x00,&UBR11
		mov.b #0x4A,&UMCTL1
		bic.b #SWRST,&UCTL1 
		bis.b #UTXE1+URXE1,&ME2
		ret
; ***************** Port 3 Initialisation **************************
SetupP3: 	mov.b #0xC0,&P3SEL ; P3.6,7 = USART select
		mov.b #0x40,&P3DIR ; P3.6 = output direction
		mov.b #0x00,&P3OUT ; P3.6 = output val
	 	mov.b #0x00,&P5SEL ; P5
		mov.b #0xFF,&P5DIR ; P5
		mov.b #0x00,&P5OUT ; P5
		mov.b #0xEF,&portAPNdir
		mov.b #0x00,&portAPNsel
		mov.b #0xE0,&portAPNout

		ret ;
; ***************** Interrupts Initialisation **************************
;IntInit: 	bis.b #URXIE0,&IE1 ; Enable USART0 RX interrupt
;		bis.b #URXIE1,&IE2 ; Enable USART1 RX interrupt
;		; eint ; General enable interrupts
;		ret

;----------------------------------------------------------------------------- 
;       Timer_A ISR:
;       CPU is simply returned to active state on RETI by manipulated the SR
;       bits in the SR value that was pushed onto the stack.
;       CCR0 IFG is reset automatically.
;----------------------------------------------------------------------------- 

delai:
	mov.b  	#12,tmp2
del1:	mov.w	#0xffff,tmp
del2:	dec.w	tmp
	jnz	del2
	dec.b	tmp2
	jnz	del1
	ret

bin2bcd:		; in=tmp, out=tmp; modified: tmp2, tmp3
	mov	#8,tmp3
	clr.b	tmp2
binjmp:	rla.b	tmp
	dadd.b	tmp2,tmp2
	dec	tmp3
	jnz	binjmp
	mov	tmp2,tmp
	ret

bcd2bin:		; SLAA024, p.535 = p.5-60
	mov	#2,tmp5
	clr.b	tmp2
	clr.b	tmp3
	
shft4:	rla.b	tmp
	rlc.b	tmp2
	rla.b	tmp
	rlc.b	tmp2
	rla.b	tmp
	rlc.b	tmp2
	rla.b	tmp
	rlc.b	tmp2
	add.b	tmp2,tmp3
	clr.b	tmp2
	dec	tmp5
	jz	endbin
	
mpy10:	rla.b	tmp3
	mov.b	tmp3,tmp4
	rla.b	tmp3
	rla.b	tmp3
	add.b	tmp4,tmp3
	jmp	shft4
endbin:	mov.b	tmp3,tmp
	ret

flash_cpw:
	mov.w	#0x0A500,&FCTL3
	mov.w	#0x0A540,&FCTL1
	mov.w	tmp,0(tmp2)		; write_word at flash @
	mov.w	#0x0A500,&FCTL1
	mov.w	#0x0A510,&FCTL3
	ret

flash_rmw:
	mov.w	#0x0A500,&FCTL3
	mov.w	#0x0A502,&FCTL1
	mov.w	#00,&0x1000		; erase flash Segment B 1000-107F
	mov.w	#0x0A500,&FCTL1
	mov.w	#0x0A510,&FCTL3
	ret

interrupt(TIMERA0_VECTOR)               ;register interrupt vector
.global CCR0INT                         ;place a label afterwards so
CCR0INT:        BIC     #LPM3,0(R1)     ; Clear SR LPM3 Bits, on top of stack

	        SETC                    ; Set Carry bit.
                DADC.b  SEC             ; Increment seconds decimally
                CMP.b   #0x60,SEC       ; One minute elapsed?
                JLO     Clockendi        ; No, return
                CLR.b   SEC             ; Yes, clear seconds
                DADC.b  MIN             ; Increment minutes decimally
                CMP.b   #0x60,MIN       ; Sixty minutes elapsed?
                JLO     Clockendi        ; No, return
                CLR.b   MIN             ; yes, clear minutes
                DADC.b  HR              ; Increment Hours decimally
                CMP.b   #0x24,HR        ; 24 hours elapsed?
                JLO     Clockendi        ; No, return
                CLR.b   HR              ; yes, clear hours	
Clockendi:     
                RETI                    ;

