; 070730: marche bien avec rtc.c mais quid avec soft christian ?
;         ecrire en flash au lieu de RAM
;         optimiser bcd2bin

// ici on conserve le gcrt0.S avec ses initialisation et on *modifie*
// la table des vecteurs d'interruption plutot que de vouloir la
// redefinir
// une des differences entre les differents MSP430 est la taille et le
// contenu de la table des vecteurs d'interruption => NE PAS les definir
// par des .word car ce n'est pas portable
// /opt/cdk4msp/bin/msp430-jtag -l /dev/.static/dev/parport1 -e jmf

// l'exemple GPS utilise une horloge externe pour 115 kbps. Ici 9600 bauds
// donc on ne prend que le quartz a 32768 Hz

#include <signal.h>
#include <io.h>

;		RTC variables
#define         demSEC     R13           // intervalle de temps 
#define         ferme     R14            // interrupteur ferme ?
#define         prise     R15            // en cours de prise de vue ?
#define		tmp	R9
#define		tmp2	R8
#define		tmp3	R7
#define		tmp4	R6
#define		tmp5	R5
; P4.0 = power ON/OFF, P4.1 = prise de vue, P4.4 = detection alim

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET:          ;MOV     #__stack,R1     ; Initialize stackpointer 0x0280
		MOV.W     #0x280,R1
		
                CALL    #Setup          ; Prepare LCD and basic timmer

Mainloop:     
		BIS     #LPM3,R2        ; Set SR bits for LPM3
		CALL	#Alarm

                JMP     Mainloop        ; Endless Loop

rs_tx:		bit.b	#UTXIFG0,&IFG1	; p.13-29: UTXIFG0 set if U0TXBUF empty
		jz	rs_tx
		mov.b	tmp,&TXBUF0	;
		ret
	
;----------------------------------------------------------------------------- 
;    Clock: Update clock SEC and MIN and HR
;    Originally written by Lutz Bierl.
;    This is the routine that counts the hours, minutes and seconds.
;    It can be used with any counter peripheral on any MSP430 device,
;    as long as it is executed once per second.
;    This particular routine is very basic.  It only counts minutes, seconds
;    and hours as BCD numbers.  Hex values could also be used if desired.
;    Refer to the MSP430 Application Report Book for more extensive clock
;    routines that include counters for years, adjustments for leap years, etc.
;----------------------------------------------------------------------------- 

Alarm:	
	bit.b	#0x01,&P5IN
	jz	finprise
	xor.b	#0xFF,prise
	xor.b	#8,&P5OUT
finprise:
        mov.b	&P4IN,tmp3
	CMP.b   tmp3,demSEC 
	jne	pasalm
	xor.b	#0x10,&P5OUT	
	cmp.b	#0xff,prise
	jne	pasprise
	mov.b	#1,ferme
	bis.b	#4,&P5OUT
pasprise:clr	demSEC		; recommence counter
	jmp	finalm
pasalm:	
	add.b	#1,demSEC
        CMP.b   #1,ferme      	;
	jne	finalm
        CMP.b   #1,demSEC     	; si demSEC==1 && ferme==1, alors ferme=0
	jne	finalm
	mov	#0,ferme
	bic.b	#0x04,&P5OUT

finalm:	
	ret

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV     #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

setupTA:        MOV     #TASSEL0+TACLR, &TACTL  ; ACLK for Timer_A.
                BIS     #CCIE,&CCTL0            ; Enable CCR0 interrupt.
                MOV     #0x1FFF,&CCR0           ; load CCR0 with 32,767/2.
                BIS     #MC0,&TACTL             ; start TA in "up to CCR0" mode

ClearRTC:       MOV.b   #0,demSEC               ; Clear SEC
                MOV.b   #0,ferme                ; Clear MIN
                MOV.b   #0,prise                ; Clear HR
                EINT                            ; Enable interrupts

;		call #SetupUART0
		call #SetupP3

                RET                     ; Done with setup.

; ***************** UART 0 Initialisation **************************
; nb: SMCLK has been divided by 4, must compensate for divider register
SetupUART0: 	mov.b #SWRST,&UCTL0	; cf p.13-4
		bis.b #CHAR,&UCTL0 	; 8-bit characters: 13-22
		mov.b #SSEL0,&UTCTL0 	; UCLK = ACLK @ 32768 Hz
		mov.b #0x03,&UBR00 	; 
		mov.b #0x00,&UBR10 	; cf p.13-16: 9600 bauds +/- 15%
		mov.b #0x4A,&UMCTL0 	; 
		bic.b #SWRST,&UCTL0 
		bis.b #UTXE0+URXE0,&ME1 ; Enable USART0 TXD/RXD
		nop
		ret
; ***************** Port 3 Initialisation **************************
SetupP3: 	bis.b 	#0xF0,&P3SEL ; P3.4,5,6,7 = USART select
		bis.b 	#0x50,&P3DIR ; P3.4,6 = output direction
		
		bic.b 	#0xFF,&P4DIR
		mov.b	#0x00,&P4SEL
		mov.b	#0x00,&P4OUT
		
		mov.b 	#0xFE,&P5DIR
		mov.b	#0x00,&P5SEL
		mov.b	#0x00,&P5OUT

		ret ;
; ***************** Interrupts Initialisation **************************
;IntInit: 	bis.b #URXIE0,&IE1 ; Enable USART0 RX interrupt
;		bis.b #URXIE1,&IE2 ; Enable USART1 RX interrupt
;		; eint ; General enable interrupts
;		ret

;----------------------------------------------------------------------------- 
;       Timer_A ISR:
;       CPU is simply returned to active state on RETI by manipulated the SR
;       bits in the SR value that was pushed onto the stack.
;       CCR0 IFG is reset automatically.
;----------------------------------------------------------------------------- 

delai:
	mov.b  	#20,tmp2
del1:	mov.w	#0xffff,tmp
del2:	dec.w	tmp
	jnz	del2
	dec.b	tmp2
	jnz	del1
	ret

bin2bcd:		; in=tmp, out=tmp; modified: tmp2, tmp3
	mov	#8,tmp3
	clr.b	tmp2
binjmp:	rla.b	tmp
	dadd.b	tmp2,tmp2
	dec	tmp3
	jnz	binjmp
	mov	tmp2,tmp
	ret

bcd2bin:
	mov	#2,tmp5
	clr.b	tmp2
	clr.b	tmp3
	
shft4:	rla.b	tmp
	rlc.b	tmp2
	rla.b	tmp
	rlc.b	tmp2
	rla.b	tmp
	rlc.b	tmp2
	rla.b	tmp
	rlc.B	tmp2
	add.b	tmp2,tmp3
	clr.b	tmp2
	dec	tmp5
	jz	endbin
	
mpy10:	rla.b	tmp3
	mov.b	tmp3,tmp4
	rla.b	tmp3
	rla.b	tmp3
	add.b	tmp4,tmp3
	jmp	shft4
endbin:	mov.b	tmp3,tmp
	ret

interrupt(TIMERA0_VECTOR)               ;register interrupt vector
.global CCR0INT                         ;place a label afterwards so
CCR0INT:        BIC     #LPM3,0(R1)     ; Clear SR LPM3 Bits, on top of stack
                RETI                    ;
