// TODO : varicap sur resonateur
//        PWM puis LPF en sortie
// 	  ADC12 pour mesurer T (channel 0x0A) : Vtemp=0.00355*(Tc)+0.986 p.17-16
//              -> probleme de capa de decouplage ?
//        mesurer freq en fontion de T
//        balayer tension de polar de varicap et voir comment f_osc varie (deja
//           tester avec capas fixes pour choisir la varicap p.r a 12 pF)
// frequence inf de l'aeoflex ?
// 5000000%65536=19264 et 5000000/65536=76 => voir meme chose sur osc RF

; attention a P1SEL pour selectionner le mode de fonctionnement d'une broche

// ici on conserve le gcrt0.S avec ses initialisation et on *modifie*
// la table des vecteurs d'interruption plutot que de vouloir la
// redefinir
// une des differences entre les differents MSP430 est la taille et le
// contenu de la table des vecteurs d'interruption => NE PAS les definir
// par des .word car ce n'est pas portable
// /opt/cdk4msp/bin/msp430-jtag -l /dev/.static/dev/parport1 -e jmf

// l'exemple GPS utilise une horloge externe pour 115 kbps. Ici 9600 bauds
// donc on ne prend que le quartz a 32768 Hz

#include <signal.h>
#include <io.h>

//#define hi	1	
	
#define         SEC     R13            

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET:  ;MOV     #__stack,R1     ; Initialize stackpointer 0x0280
	MOV.W   #0x280,R1
		
        CALL    #Setup          ; Prepare LCD and basic timmer

Mainloop:
	mov.b	#0,SEC
at:     CMP.b   #1,SEC       ; Sixty minutes elapsed?
	jne	at
		
;	BIS     #LPM3,R2        ; Set SR bits for LPM3: ACLK active
	nop
;	xor.b	#4,&P1OUT 

	mov.w	&CCR0,SEC	; read timer A input capture current value

	call 	#rs_TX
	swpb	SEC
	call 	#rs_TX

; a chaque PPS, on renvoie la temperature du MSP430 => courbe f(T)
	call	#SetupADC12
	call 	#rs_TX
	swpb	SEC
	call 	#rs_TX
	
/*
	mov.w	#0x8000,R7
attend:	dec	R7
	jnz	attend
*/

;	inc.b	SEC
;        CMP.b   #127,SEC       ; Sixty minutes elapsed?
;	JNE     Mainloop        ; No, return
;
;	MOV.b     #0x20,SEC
;	xor.b	#4,&P1OUT 
;	nop

;; APPLIQUER ICI LA PID ET RENVOYER LA CONSIGNE APPLIQUEE AU QUARTZ

        JMP     Mainloop        ; Endless Loop

//////// send SEC on UART0 ////////
rs_TX:	bit.b	#UTXIFG0,&IFG1	; p.13-29: UTXIFG0 set when U0TXBUF empty
	jz	rs_TX
	mov.b	SEC,&TXBUF0
	ret

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV.w   #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

/* Configuration des registres du Timer A pour capturer a chaque seconde du GPS,
le contenu de l'horloge, afin de verifier par la suite la difference entre la 
seconde du quartz de 32 kHz et la seconde du GPS*/
			
		call #SetupOsc		; A VIRER SI ON PREND 32 kHz

; setupTA:        MOV     #TASSEL0+TACLR, &TACTL  ; ACLK for Timer_A.
setupTA:        MOV.w   #TASSEL1+TACLR, &TACTL  ; SMCLK for Timer_A.
                BIS	#MC1,&TACTL             ; start TA in "up to FFFF" mode
		mov.w	#CM0+CAP+CCIE+SCS,&TACCTL0	; mode capture sur front montant
// jmfriedt: /opt/cdk4msp/msp430/include/msp430/timera.h

		MOV	 #0x04,&P1OUT
		MOV	 #0x02,&P1SEL		; p.9-4: P1_1 is TA, NOT GPIO
		MOV	 #0x04,&P1DIR
		; MOV	 #0,&P1IES		; jmf
		; MOV	 #0,&P1IE		; jmf

		MOV.b   #0x20,SEC               ; SEC=' ' for RS232 tests
                EINT                            ; Enable interrupts

#ifdef hi
		call #SetupUART0
		call #SetupP3
#else		
		call #SetupUART0
		call #SetupP3
#endif

setupTB:	MOV.w   #TBSSEL1+TBCLR, &TBCTL  ; SMCLK for Timer_B.
		mov.w	#CCIE,&TBCCTL0		; compare mode 
		mov.w	#0xFF,&TBCCR0		; period of PWM: 8 bits DAC
		mov.w	#0x02E0,&TBCCTL3
		mov.w	#0xAA,&TBCCR3		; Vout=2/3 Vcc ($AA=2/3 $FF)
		bis	#MC0,&TBCTL
                RET                     ; Done with setup.

//////////////////////////////////////////////////////////////////////////
SetupADC12:	; book C. Nagy p.90
		mov.w	#SHT0_6+SHT1_6+REFON+ADC12ON,&ADC12CTL0
		mov.w	#SHP,&ADC12CTL1
		mov.b	#INCH_10+SREF_1,&ADC12MCTL0 ; p.17-11: single conversion
		bis.w	#ENC+ADC12SC,&ADC12CTL0		; MUST be .w jmfriedt
adc:		bit.b	#1,&ADC12CTL1	; wait while ADC busy==1
		jnz	adc
		mov.w	&ADC12MEM0,SEC	; conversion result
		ret

//////////////////////////////////////////////////////////////////////////
SetupOsc: 	bic.b 	#XT2OFF,&BCSCTL1 	; XT2on
		bic.b 	#OFIFG,&IFG1 		; Clear OSC fault flag
		mov 	#0xFF,R15 		; R15 = Delay
SetupOsc1: 	dec 	R15 			; Additional delay ensure start
		jnz 	SetupOsc1 		;
		bit.b 	#OFIFG,&IFG1 		; OSC fault flag set?
		jnz 	SetupOsc 		; OSC Fault, clear flag again
		bis.b 	#SELM0+SELS,&BCSCTL2 	; MCLK = SMCLK = XT2      ?SELS?
		;mov.b	#0x56,&DCOCTL	;; A VIRER ?
		;; un nop a cet endroit fait planter l'execution !
		ret

; ***************** UART 0 Initialisation **************************
; nb: SMCLK has been divided by 4, must compensate for divider register
SetupUART0: 	mov.b 	#SWRST,&UCTL0		; cf p.13-4
		bis.b 	#CHAR,&UCTL0 		; 8-bit characters: 13-22
#ifdef hi
		mov.b 	#SSEL1,&UTCTL0 		; UCLK = SMCLK
		mov.b 	#78,&UBR00 		; 4.9152 Mhz 9600 - 
		mov.b 	#0x00,&UBR10 		; 
		mov.b 	#0x00,&UMCTL0 		; 4.9152 MHz no modulation 4800
#else
		mov.b 	#SSEL0,&UTCTL0 		; UCLK = ACLK @ 32768 Hz
		mov.b 	#0x03,&UBR00 		; 
		mov.b 	#0x00,&UBR10 		; cf p.13-16: 9600 bauds +/- 15%
		mov.b 	#0x4A,&UMCTL0 		; 
#endif
		bic.b 	#SWRST,&UCTL0 
		bis.b 	#UTXE0+URXE0,&ME1 	; Enable USART0 TXD/RXD
		nop
		ret
; ***************** UART 1 Initialisation
; nb: SMCLK has been divided by 4, must
;SetupUART1: 	mov.b 	#CHAR,&UCTL1
;		mov.b 	#SSEL1,&UTCTL1
;		mov.b 	#0x08,&UBR01
;		mov.b 	#0x00,&UBR11
;		mov.b 	#0x00,&UMCTL1
;		bis.b 	#UTXE1+URXE1,&ME2
;		ret
; ***************** Port 3 Initialisation **************************
SetupP3: 	bis.b 	#0xF0,&P3SEL 		; P3.4,5,6,7 = USART select
		bis.b 	#0x50,&P3DIR 		; P3.4,6 = output direction
		ret ;
; ***************** Interrupts Initialisation **************************
;IntInit: 	bis.b 	#URXIE0,&IE1 		; Enable USART0 RX interrupt
;		bis.b 	#URXIE1,&IE2 		; Enable USART1 RX interrupt
;		; eint ; General enable interrupts
;		ret

;----------------------------------------------------------------------------- 
;       Timer_A ISR:
;       CPU is simply returned to active state on RETI by manipulated the SR
;       bits in the SR value that was pushed onto the stack.
;       CCR0 IFG is reset automatically.
;----------------------------------------------------------------------------- 

; jmfriedt: /opt/cdk3msp/msp430/include/msp430x14x.h pour les diverses tables 
; l'exemple TI qui definit une table fixe et se compile sans entete est mauvais
interrupt(TIMERA0_VECTOR)               ; register interrupt vector
.global CCR0INT                         ; place a label afterwards so
CCR0INT:;        BIC     #LPM3,0(R1)     ; Clear SR LPM3 Bits, on top of stack
		mov.b	#1,SEC
                RETI

interrupt(TIMERB0_VECTOR)
.global CCIFG0
CCIFG0: 	RETI			; leave CCR3 unchanged for DAC
