#include <signal.h>
#include <io.h>

#define         an      R15
#define 	mois    R14
#define         jour    R13
#define         tmp     R10	

;----------------------------------------------------------------------------- 
;               Program main
;----------------------------------------------------------------------------- 
.global main            
main:	
RESET: 
	MOV.W   #0x880,R1	; stack = 0x200-0x280 // NE MARCHE PAS AVEC 280
        CALL    #Setup

	mov.w	#2007,an
	mov.w	#0,mois
	mov.w	#0,jour

Mainloop:
	mov	an,tmp		; return() dans R15:R14 (unsigned long)
	call 	#rs_TX		; envoi sur port com.
	mov	mois,tmp		; return() dans R15:R14 (unsigned long)
	call 	#rs_TX
	mov	jour,tmp
	call 	#rs_TX

	push	R15
	push	R14		; on veut se rappeler de la position du tablo
	push	R13		; DAC va etre remplace par PID.c
	CALL    #sunriseset
	mov	an,tmp		; return() dans R15:R14 (unsigned long)
	call 	#rs_TX		; envoi sur port com.
	swpb	tmp
	call 	#rs_TX
	mov	mois,tmp
	call 	#rs_TX
	swpb	tmp
	call 	#rs_TX
	
	pop	R13
	pop	R14
	pop	R15
	inc.b	jour
	jne	Mainloop
fin:    JMP     fin       

//////// send tmp on UART0 ////////
rs_TX:	bit.b	#UTXIFG1,&IFG2	; p.13-29: UTXIFG0 set when U0TXBUF empty
	jz	rs_TX
	mov.b	tmp,&TXBUF1
	ret

;----------------------------------------------------------------------------- 
;	 Setup: Configure Modules and Control Registers 
;----------------------------------------------------------------------------- 
Setup:          MOV.w   #WDTPW+WDTHOLD,&WDTCTL  ; Stop Watchdog Timer

		MOV	#0x14,&P1OUT
		MOV	#0x12,&P1SEL		; 
		MOV	#0x14,&P1DIR
                EINT                            ; Enable interrupts

 		call	#SetupUART0
		call 	#SetupUART1
		call	#SetupP3

                RET				; Done with setup.


; ***************** UART 0 Initialisation **************************
; nb: SMCLK has been divided by 4, must compensate for divider register
	
SetupUART0: 	mov.b 	#SWRST,&UCTL0		; cf p.13-4
		bis.b 	#CHAR,&UCTL0 		; 8-bit characters: 13-22
		mov.b 	#SSEL0,&UTCTL0 		; UCLK = ACLK @ 32768 Hz
		mov.b 	#0x03,&UBR00 		; 
		mov.b 	#0x00,&UBR10 		; cf p.13-16: 9600 bauds +/- 15%
		mov.b 	#0x4A,&UMCTL0 		; 
		bic.b 	#SWRST,&UCTL0 
		bis.b 	#UTXE0+URXE0,&ME1 	; Enable USART0 TXD/RXD
		nop
		ret

; ***************** Port 3 Initialisation **************************
SetupP3: 	bis.b 	#0xF0,&P3SEL 		; P3.4,5,6,7 = USART select
		bis.b 	#0x50,&P3DIR 		; P3.4,6 = output direction
		ret ;

;----------------------------------------------------------------------------- 
; ***************** UART 1 Initialisation
; nb: SMCLK has been divided by 4, must
SetupUART1: 	mov.b #SWRST,&UCTL1	; cf p.13-4
	 	bis.b #CHAR,&UCTL1
		mov.b #SSEL0,&UTCTL1
		mov.b #0x03,&UBR01
		mov.b #0x00,&UBR11
		mov.b #0x4A,&UMCTL1
		bic.b #SWRST,&UCTL1 
		bis.b #UTXE1+URXE1,&ME2
		ret
